<?php

/**
 * BuddyServ IRC Services
 * 
 * Debug backtracing class
 * 
 * @name Debug
 * @author Raymond Lynk <me@raymondj.ca>
 * @copyright (C) 2010, Raymond Lynk
 * @link http://buddyserv.raymondj.ca
 * @package Core
 * @version $Id: Class.debug.php 318 2009-11-14 04:17:22Z lynk $
 */

/*
 * 		 ______           __     __         _______                        
 * 		|   __ \.--.--.--|  |.--|  |.--.--.|     __|.-----.----.--.--.     
 * 		|   __ <|  |  |  _  ||  _  ||  |  ||__     ||  -__|   _|  |  |     
 * 		|______/|_____|_____||_____||___  ||_______||_____|__|  \___/      
 *  				    			   |_|                                 
 *                                                                         
 */

class debug
{
	public $backtrace;
	
	/**
	 * Constructs a debug message
	 * 
	 * @param string $message
	 * @param bool $backtrace
	 * @return debug
	 */
	public function __construct($message,$backtrace=false)
	{
		global $irc, $me;
		
		monitor::$client->msg($me->coders_channel, "\0037Debug\003: ".$message);
		
		if ($backtrace)
		{
			$backtrack = debug_backtrace();
			monitor::$client->msg($me->coders_channel, "@@@ Debug Backtrace @@@");
			
			$i = 1;
			
			foreach ($backtrack as $entry)
			{
				monitor::$client->msg($me->coders_channel, "\2#".$i."\2");
                monitor::$client->msg($me->coders_channel, "File: ".$entry['file']." (Line: ".$entry['line'].")");
                monitor::$client->msg($me->coders_channel, "Function: ".$entry['function']);
                monitor::$client->msg($me->coders_channel, "Args: ".implode(", ", $entry['args']));
                monitor::$client->msg($me->coders_channel, "-------------------------------------");
			}
        }
	}
}

?>	