<?php

/**
 * BuddyServ IRC Services
 * 
 * Error event handler
 * 
 * @name Error
 * @author Raymond Lynk <me@raymondj.ca>
 * @copyright (C) 2010, Raymond Lynk
 * @link http://buddyserv.raymondj.ca
 * @package Core
 * @version $Id: Class.error.php 318 2009-11-14 04:17:22Z lynk $
 */

/*
 * 		 ______           __     __         _______                        
 * 		|   __ \.--.--.--|  |.--|  |.--.--.|     __|.-----.----.--.--.     
 * 		|   __ <|  |  |  _  ||  _  ||  |  ||__     ||  -__|   _|  |  |     
 * 		|______/|_____|_____||_____||___  ||_______||_____|__|  \___/      
 *  				    			   |_|                                 
 *                                                                         
 */

/* * * Thoughts * * *
 *
 * J.23.09 - Queue is handled from the irc class. It is a global mechanism.
 * 			 Config will dicate if we also want to log to file, to channel, both, none
 ********************/
 
/* Error class */
	
final class error
{
	/**
	 * Sends an error message to the coders channel,
	 * and echos to console.
	 * 
	 * @param bool $fatal
	 * @param string $message
	 * @return error
	 */
	public function __construct($fatal,$message)
	{
		global $me, $irc;
		
		if ($fatal)
			$tag = 'Fatal: ';
		
		else
			$tag = 'Warning: ';
			
			operserv::$client->msg($me->coders_channel, $tag. " ".$message);
			
			echo "\n".$tag." ".$message."\n";
	}
}
			
?>