<?php

/**
 * BuddyServ IRC Services
 * 
 * Contains most configuration options
 * for the BuddyServ pseudo clients, and
 * official channels.
 * 
 * @name Me
 * @author Raymond Lynk <me@raymondj.ca>
 * @copyright (C) 2010, Raymond Lynk
 * @link http://buddyserv.raymondj.ca
 * @package Ircd
 * @version $Id: Class.me.php 331 2009-11-22 04:21:18Z lynk $
 */

/*
 * 		 ______           __     __         _______                        
 * 		|   __ \.--.--.--|  |.--|  |.--.--.|     __|.-----.----.--.--.     
 * 		|   __ <|  |  |  _  ||  _  ||  |  ||__     ||  -__|   _|  |  |     
 * 		|______/|_____|_____||_____||___  ||_______||_____|__|  \___/      
 *  				    			   |_|                                 
 *                                                                         
 */

class me
{
	public $name;
	public $password;
	public $description;
	public $uplink;
	public $chanserv = array();
	public $nickserv = array();
	public $operserv = array();
	public $userbot = array();
	public $monitor = array();
	public $version = '1.5.1'; 					// version
	public $url;
	public $staff_channel; 			// irc stats channel 
	public $user_channel; 		// main channel
	public $support_channel; 		// support channel
	public $uploader_channel; 	// uploaders automation
	public $coders_channel; 		// coders channel
	public $sysop_channel;			// sysop channel.
	public $syslog_verbose = true;
	public $started;
	
	/* RRD Graph information */
	public $use_rrd = true;
	public $rrd_file = 'rrd/ircusage.rrd'; // path to the rrd data file.
	public $rrd_pnglocation = 'rrd/irc.png'; // path where you want to store the image 
	
	public function __construct($name, $password, $description)
	{
		global $config, $site;
		
		$this->started = time();
		$this->name = $name;
		$this->password = $password;
		$this->description = $description;
		
		/* Set the channels */
		$this->staff_channel = $config['channels']['STAFF'];
		$this->user_channel = $config['channels']['USER'];
		$this->support_channel = $config['channels']['SUPPORT'];
		$this->uploader_channel = $config['channels']['UPLOADER'];
		$this->sysop_channel = $config['channels']['SYSOP'];
		$this->coders_channel = $config['channels']['CODER'];
		
		/* Set some other values */
		$this->use_rrd = $config['useRRD'];
		
		if (!$site)
		{
			// not debug
			$this->url = $config['site']['production']['URL'];
		}
		
		else
		{
			$this->url = $config['site']['development']['URL'];
		}
		
		$this->chanserv = $config['clients']['chanserv'];
		$this->nickserv = $config['clients']['nickserv'];
		$this->operserv = $config['clients']['operserv'];
		$this->memoserv = $config['clients']['memoserv'];
		$this->userbot  = $config['clients']['userbot'];
		$this->monitor  = $config['clients']['buddyserv'];
	}
}


?>