<?php
/**
 * BuddyServ IRC Services
 * 
 * Client commands listing. Contains all available
 * service -> ircd commands.
 * 
 * @name IRCRaw
 * @author Raymond Lynk <me@raymondj.ca>
 * @copyright (C) 2010, Raymond Lynk
 * @link http://buddyserv.raymondj.ca
 * @package Ircd
 * @version $Id: ircraw.php 328 2009-11-19 06:55:49Z lynk $
 */

/*
 * 		 ______           __     __         _______                        
 * 		|   __ \.--.--.--|  |.--|  |.--.--.|     __|.-----.----.--.--.     
 * 		|   __ <|  |  |  _  ||  _  ||  |  ||__     ||  -__|   _|  |  |     
 * 		|______/|_____|_____||_____||___  ||_______||_____|__|  \___/      
 *  				    			   |_|                                 
 *                                                                         
 */

/* A B C D E */
define('CAPAB',		'CAPAB :UNKLN KLN TBURST TB EOB HUB ENCAP SERVICES');
define('EOB',		':%s EOB');

/* F G H I J */
define('INTRODUCE',  'NICK %s %d %d %s %s %s %s %d %s :%s');
define('INVITE',	':%s INVITE %s %s %d');

/* K L M N O */
define('KILL',		':%s KILL %s :%s!%s!%s!%s (%s)');
define('CTCP',		":%s NOTICE %s :\001%s\001");
define('MSG', 		':%s PRIVMSG %s :%s');
define('NOTICE', 	':%s NOTICE %s :%s');
define('MODE',		':%s MODE %s %s');
define('KLINE',		':%s KLINE * %d %s %s :%s');
define('KICK',		':%s KICK %s %s :%s');

/* P Q R S T */
define('PASS',		'PASS %s TS 5');
define('PONG',		'PONG :%s');
define('QUIT',		':%s QUIT :%s');
define('RAW',		'%s');
define('PART',		':%s PART %s :%s');
define('SERVER',	'SERVER %s %d :%s');
define('SVINFO',	'SVINFO %d %d %d :%d');
define('SVSNICK',	'ENCAP * SVSNICK %s %d %s %d');
define('RESV',		':%s RESV * %s :%s');
define('SJOIN',		':%s SJOIN %d %s %s :%s');
define('TOPIC',		':%s TOPIC %s :%s');
define('OPERWALL',	':%s OPERWALL :%s');

/* U V W X Y Z */
define('USERMODE',	':%s MODE %s %s'); //nick, modes
define('UNKLINE',	':%s UNKLINE * %s %s');
define('WHOIS',		'WHOIS %s %s');


/* Server response codes */
	
$response_codes = array(
	'RPL_PASS' 		=> '/^PASS (\S+) TS \d{1} .*/',
	'RPL_CAPAB'		=> '/^CAPAB :.*/',
	'RPL_SERVER'	=> '/^SERVER (\S+) \d{1,2} :(.+)$/',
	'RPL_SVINFO'	=> '/^SVINFO (\d+) (\d+) (\d+) :(\d{11})$/',
	'RPL_INTRODUCE'	=> '/^NICK (\S+) \d+ (\d+) (\S+) (\S+) (\S+) (\S+) \d+ (\S+) :(.+)$/',
	'RPL_SJOIN'		=> '/^:(\S+) SJOIN (\d+) (\S+) (.*)\s*:(.+)$/',
	'RPL_EOB'		=> '/^:(\S+) EOB$/',
	'RPL_PING'		=> '/^PING :(\S+)$/',
	'RPL_ERROR'		=> '/^ERROR :Closing Lynk: (\S+) (.+)$/',
	'RPL_SHORT'		=> '/^:(\S+) PRIVMSG (\S+)\@\S+ :(.+)$/',
	'RPL_CVERSION'	=> '/^:(\S+) PRIVMSG (\S+) :\001VERSION\001$/',
	'RPL_CPING'		=> '/^:(\S+) PRIVMSG (\S+) :\001PING (\d+)\001$/',
	'RPL_CUPTIME'	=> '/^:(\S+) PRIVMSG (\S+) :\001INFO\001$/',
	'RPL_PRIVMSG'	=> '/^:(\S+) PRIVMSG (\S+) :(.+)$/',
	'RPL_PART'		=> '/^:(\S+) PART (\S+)/',
	'RPL_QUIT'		=> '/^:(\S+) QUIT/',
	'RPL_KILL'		=> '/^:(\S+) KILL (\S+) :.+/',
	'RPL_NEWNICK'	=> '/^:(\S+) NICK (\S+) :(\d+)/',
	'RPL_UMODE'		=> '/^:(\S+) MODE \1 :(\S+)$/',
	'RPL_TOPIC'		=> '/^:(\S+) TOPIC (\S+) :(.+)/',
	'RPL_KICK'		=> '/^:(\S+) KICK (\S+) (\S+)/',
	'RPL_CMODE'		=> '/^:(\S+) MODE (\S+) (.+)/'
);

?>